package com.pqs9900.serviceImpl.HisData;

import com.pqs9900.mapper.HisData.DataHarmpowerPMapper;
import com.pqs9900.pojo.HisData.DataHarmpowerP;
import com.pqs9900.service.HisData.DataHarmpowerPService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;

/** @Author denghuajun
 * @Description //TODO 三相有功功率
 * @Date  2018/12/17 10:53
 **/
@Service
public class DataHarmpowerPServiceImpl implements DataHarmpowerPService {

    private static final Logger logger= LoggerFactory.getLogger(DataHarmpowerPServiceImpl.class);

    @Autowired
    private ThreadPoolTaskExecutor taskExecutor;

    @Autowired
    private DataHarmpowerPMapper dataHarmpowerPMapper;
    @Override
    public int saveDataHarmpowerP(DataHarmpowerP dataHarmpowerP) {
        return dataHarmpowerPMapper.insert(dataHarmpowerP);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public int insertDataHarmpowerP(List<DataHarmpowerP> list) {
        return dataHarmpowerPMapper.insertDataHarmpowerP(list);
    }

    /**
     * 采用线程池进行数据入库
     * @param listDataHarmpowerP 三相有功功率数据
     */
    @Override
    public Future insertDataHarmpowerPExecutor(List<DataHarmpowerP> listDataHarmpowerP) {
        int inum = 100 ;//每次解析入库条目数
        Callable callable = new Callable() {
            @Override
            public Object call() throws Exception {
                int nCyclicTimes;//循环次数（总长度/批量入库条目数）
                int fromIndex,toIndex;//获取数据的起始和结束下标
                try {
                    nCyclicTimes = (int) Math.ceil(listDataHarmpowerP.size() / (double) inum);
                    List<DataHarmpowerP> tmpListDataHarmpowerP = new ArrayList<>();
                    for (int i = 0; i < nCyclicTimes; i++) {
                        tmpListDataHarmpowerP.clear();
                        //假如是最后一次循环则获取循环到结束
                        fromIndex = i * inum;
                        if (i == nCyclicTimes - 1) {
                            toIndex = listDataHarmpowerP.size();
                        } else {
                            toIndex = (i + 1) * inum;
                        }
                        //可以先按下标截取，再入库
                        tmpListDataHarmpowerP.addAll(listDataHarmpowerP.subList(fromIndex, toIndex));
                        // TODO 做批量入库的操作
                        dataHarmpowerPMapper.insertDataHarmpowerP(tmpListDataHarmpowerP);
                    }
                    return "SUCCESS";
                } catch (Exception e) {
                    logger.error("三相有功功率导入异常，异常是" + e.toString());
                    return "FAIL";
                }
            }
        };
        return taskExecutor.submit(callable);
    }
}
